<?php
/*
Plugin Name: FilterFeeder
Plugin URI: http://www.canonical.com/
Description: Allows you to filter things out of a feed
Version: 1.0
Author: Chris Jones
Author URI: http://www.canonical.com/

Copyright 2009 Canonical

All Rights Reserved
*/

function filter_filterfeeder_posts($content) {
	if(!is_feed()) {
		// This isn't a feed. Stop caring and just return the data
		return $content;
	} else {
		if ($_SERVER['REMOTE_ADDR'] != '127.0.0.1' && $_SERVER['REMOTE_ADDR'] != '91.189.94.241') {
			// This is a public request, return all the data
			return $content;
		} else {
			// This feed request is coming from the local machine, so it's feedjack. neuter out the posts it gave us
			$newcontent = array();

			foreach ($content as $post) {
				$is_foreign = get_post_meta($post->ID, 'syndicated', true);
				if ($is_foreign != true) {
					$newcontent[] = $post;
				} 
			}

			return($newcontent);
		}
	}
}

add_filter('the_posts', 'filter_filterfeeder_posts');
?>
