<?php
/*
 *  Wordpress Launchpad plugin
 *  Copyright (C) 2009-2010 Canonical Ltd.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Custom WordPress User Page for Launchpad login
 *
 */
?>
<style type="text/css">
#loginform {
    padding-bottom:15px;
}

#loginform div.submit {
    text-align: center;
    float:none;
}
</style>
</head>
<body class="login">
<div id="login">
    <h1><a href="<?php echo apply_filters('login_headerurl', 'http://wordpress.org/'); ?>"
           title="<?php echo apply_filters('login_headertitle', __('Powered by WordPress')); ?>">
            <?php bloginfo('name'); ?>
    </a></h1>
<?php
// Reproduce WP's message showing from wp-login.php
global $wp_error;
if (empty($wp_error)) {
    $wp_error = new WP_Error();
}

global $message;
if (!empty($message)) {
    echo apply_filters('login_message', $message) . "\n";
}

// Compute $redirect_to
if (isset( $_REQUEST['redirect_to'])) {
    $redirect_to = $_REQUEST['redirect_to'];
} else {
    $redirect_to = admin_url();
}

// In case a plugin uses $error rather than the $errors object
global $error;
if (!empty($error)) {
    $wp_error->add('error', $error);
    unset($error);
}

// Some parts of this script use the main login form to display a message
if (isset($_GET['loggedout']) && TRUE == $_GET['loggedout']) {
    $wp_error->add('loggedout', __('You are now logged out.'), 'message');
}

if ($wp_error->get_error_code()) {
    $errors = '';
    $messages = '';
    foreach ($wp_error->get_error_codes() as $code) {
        $severity = $wp_error->get_error_data($code);
        foreach ($wp_error->get_error_messages($code) as $error) {
            if ('message' == $severity)
                $messages .= '	' . $error . "<br />\n";
            else
                $errors .= '	' . $error . "<br />\n";
        }
    }
    if (!empty($errors)) {
        echo '<div id="login_error">' . apply_filters('login_errors', $errors) . "</div>\n";
    }
    if (!empty($messages)) {
        echo '<p class="message">' . apply_filters('login_messages', $messages) . "</p>\n";
    }
}

    $login_button = __('Login');

// if (strpos(openid_launchpad_get_server(), 'ubuntu') === false) {
//     $login_button = __('Login with Launchpad');
// } else {
//    $login_button = __('Login with Ubuntu Single Sign On');
// }
?>
<form name="loginform" id="loginform"
      action="<?php echo site_url('wp-login.php', 'login_post') ?>"
      method="post">
    <div class="submit">
      <input type="submit" name="launchpad" value="<?php echo
        $login_button; ?>" id="lplogin" />
        <input type="hidden" name="redirect_to"
               value="<?php echo attribute_escape($redirect_to); ?>" />
        <input type="hidden" name="testcookie" value="1" />
    </div>
</form>

</div>

<p id="backtoblog">
  <a href="<?php bloginfo('url'); ?>/" title="<?php _e('Are you lost?') ?>">
    <?php printf(__('&laquo; Back to %s'), get_bloginfo('title', 'display' )); ?>
  </a>
</p>

<script type="text/javascript">
try{document.getElementById('lplogin').focus();}catch(e){}
</script>
</body>
</html>
